{$A+,B+,F+,I+,L-,O-,R-,S-,V-}
unit common;

interface

uses
  crt,dos,timejunk,printer,execswap,
  myio;

{$I func.pas}
{$I records.pas}

const strlen=160;
      dsaves:integer=0;
      BOXEDTITLE='`#[';
      sepr2=#3#9+'\'+#3#0;
      registd:boolean=FALSE;

var uf:file of userrec;           { USER.LST                              }
    bf:file of boardrec;          { BOARDS.DAT                            }
    xf:file of protrec;           { PROTOCOL.DAT                          }
    ulf:file of ulrec;            { UPLOADS.DAT                           }
    ulff:file of ulfrec;          { *.DIR                                 }
    sf:file of smalrec;           { NAMES.LST                             }
    verbf:file of verbrec;        { VERBOSE.DAT                           }
    multinodef:file of noderec;
    clasicnode:astr;

    descrec:file of filedesc;     { FILE_ID.DIZ prefs }
    dsrec:filedesc;

    mixf:file;                    { *.MIX                                 }
    brdf:file;                    { *.BRD                                 }
    sysopf,                       { SYSOP.LOG                             }
    sysopf1,                      { SLOGxxxx.LOG                          }
    trapfile,                     { TRAP*.MSG                             }
    cf:text;                      { CHAT*.MSG                             }
    small:smalrec;
    systat:systatrec;             { configuration information             }
    fstring:fstringrec;           { string configuration                  }
    modemr:modemrec;              { modem configuration                   }
    fidor:fidorec;                { FidoNet information                   }

    thisuser:userrec;             { user's account records                }
    zscanr:zscanrec;              { user's zscan records                  }

    { BRD files }
    msg_on:integer;               { current message being read            }

    { EVENTS }
    events:array[0..maxevents] of ^eventrec;
    numevents:integer;            { # of events                           }

    { PROTOCOLS }
    protocol:protrec;             { protocol in memory                    }
    numprotocols:integer;         { # of protocols                        }

    { FILE BASES }
    memuboard,tempuboard:ulrec;   { uboard in memory, temporary uboard    }
    readuboard,                   { current uboard # in memory            }
    maxulb,                       { # of file bases                       }
    fileboard:integer;            { file base user is in                  }

    { MESSAGE BASES }
    memboard:boardrec;            { board in memory                       }
    readboard,                    { current board # in memory             }
    numboards,                    { # of message bases                    }
    board:integer;                { message base user is in               }

    { FILE/MESSAGE BASE COMPRESSION TABLES }
    ccboards:array[0..1,1..maxboards] of byte;
    ccuboards:array[0..1,0..maxuboards] of byte;

    spd:string[6];                { current modem speed, "KB" for local   }

(*****************************************************************************)

    { message stuff }
    mintabloaded:word;            { minor table loaded }
    mintaboffset:longint;         { minor table file offset }
    mintab:array[0..99] of msgindexrec; { minor table }
    himsg:longint;                { highest message number }
    himintab:longint;             { highest minor table number }


    buf:string[255];              { macro buffer                          }

    sitedatetime:packdatetime;    { last time site compiled/changed status }


    cmdlist,                      { list of cmds on current menu          }
    irt,                          { reason for reply                      }
    lastname,                     { author of last message displayed      }
    lastuname,                    { last name, whether anon or not        }
    ll,                           { "last-line" string for word-wrapping  }
    start_dir:string;             { directory BBS was executed from       }

    tim,                          { time last keystroke entered           }
    timeon:datetimerec;           { time user logged on                   }

    choptime,                     { time to chop off for system events    }
    extratime,                    { extra time - given by F7/F8, etc      }
    freetime,                     { free time                             }
    oltime:real;

    answerbaud,                   { baud rate to answer the phone at      }
    exteventtime,                 { # minutes before external event       }
    maxheapspace:longint;         { max heap space available              }

    chatt,                        { number chat attempts made by user     }
    etoday,                       { E-mail sent by user this call         }
    ftoday,                       { feedback sent by user this call       }
    lastprot,                     { last protocol #                       }
    ldate,                        { last daynum()                         }
    lil,                          { lines on screen since last pausescr() }
    mread,                        { # public messages has read this call  }
    pap,                          { characters on this line so far        }
    ptoday,                       { posts made by user this call          }
    realdsl,                      { real DSL level of user                }
    realsl,                       { real SL level of user (for F9)        }
    usernum:integer;              { user's user number                    }

    bread,                        { board loaded, or -1 for e-mail        }
    bwant:integer;

    chelplevel,                   { current help level                    }
    curco,                        { current ANSI color                    }
    elevel,                       { ERRORLEVEL to exit with               }
    tshuttlelogon:byte;           { type of special Shuttle Logon command }
    thisnode:integer;
    nodeinfo:noderec;
    areanum:array [1..150] of integer;

const
    allowabort:boolean=TRUE;      { are aborts allowed?                   }
    echo:boolean=TRUE;            { is text being echoed? (FALSE=use echo chr)}
    hangup:boolean=TRUE;          { is user offline now?                  }
    nofile:boolean=TRUE;          { did last pfl() file NOT exist?        }
    onekcr:boolean=TRUE;          { does ONEK prints<CR> upon exit?       }
    onekda:boolean=TRUE;          { does ONEK display the choice?         }
    slogging:boolean=TRUE;        { are we outputting to the SysOp log?   }
    sysopon:boolean=TRUE;         { is SysOp logged onto the WFC menu?    }
    wantout:boolean=TRUE;         { output text locally?                  }
    wcolor:boolean=TRUE;          { in chat: was last key pressed by SysOp? }
    badfpath:boolean=FALSE;       { is the current DL path BAD?           }
    badufpath:boolean=FALSE;      { is the current UL path BAD?           }
    badini:boolean=FALSE;         { was last call to ini/inu value()=0, s<>"0"? }
    bchanged:boolean=FALSE;       { was BRD file changed?                 }
    bnp:boolean=FALSE;            { was file base name printed yet?       }
    cfo:boolean=FALSE;            { is chat file open?                    }
    ch:boolean=FALSE;             { are we in chat mode?                  }
    chatcall:boolean=FALSE;       { is the chat call "noise" on?          }
    pauseme:boolean=TRUE;         { allow screen pauses?                  }
    contlist:boolean=FALSE;       { continuous message listing mode on?   }
    croff:boolean=FALSE;          { are CRs turned off?                   }
    ctrljoff:boolean=FALSE;       { turn color to #1 after ^Js??          }
    cwindowon:boolean=FALSE;      { is SysOp window ON?                   }
    doneafternext:boolean=FALSE;  { offhook and exit after next logoff?   }
    doneday:boolean=FALSE;        { are we done now? ready to drop to DOS? }
    dosansion:boolean=FALSE;      { output chrs to ImpAnsi for ANSI codes?!!? }
    fastlogon:boolean=FALSE;      { if a FAST LOGON is requested          }
    hungup:boolean=FALSE;         { did user drop carrier?                }
    incom:boolean=FALSE;          { accepting input from com?             }
    inwfcmenu:boolean=FALSE;      { are we in the WFC menu?               }
    lan:boolean=FALSE;            { was last post/email anonymous/other?  }
    lastcommandgood:boolean=FALSE;{ was last command a REAL command?      }
    lastcommandovr:boolean=FALSE; { override PAUSE? (NO pause?)           }
    macok:boolean=FALSE;          { are macros OKay right now?            }
    mailread:boolean=FALSE;       { did user delete some e-mail?          }
    menuactiv:boolean=false;      { menus are active at the moment        }
    scanfilemsg:boolean=false;    { is user at a Newscan Prompt/Menu?     }
    localioonly:boolean=FALSE;    { local I/O ONLY?                       }
    packbasesonly:boolean=FALSE;  { pack message bases ONLY?              }
    newmenutoload:boolean=FALSE;  { menu command returns TRUE if new menu to load }
    nightly:boolean=FALSE;        { execute hard-coded nightly event?     }
    nofeed:boolean=FALSE;         { }
    nopfile:boolean=FALSE;        { }
    overlayinems:boolean=FALSE;   { is overlay file in EMS memory?        }
    outcom:boolean=FALSE;         { outputting to com?                    }
    printingfile:boolean=FALSE;   { are we printing a file?               }
    quitafterdone:boolean=FALSE;  { quit after next user logs off?        }
    reading_a_msg:boolean=FALSE;  { is user reading a message?            }
    readingmail:boolean=FALSE;    { reading private mail?                 }
    read_with_mci:boolean=FALSE;  { read message with MCI?                }
    shutupchatcall:boolean=FALSE; { was chat call "SHUT UP" for this call? }
    trapping:boolean=FALSE;       { are we trapping users text?           }
    useron:boolean=FALSE;         { is there a user on right now?         }
    wantfilename:boolean=FALSE;   { display message filename in scan?     }
    wasnewuser:boolean=FALSE;     { did a NEW USER log on?                }
    write_msg:boolean=FALSE;      { is user writing a message?            }
    cfgbbs:boolean=false;         { are we in the config program?         }
    telluserevent:byte=0;     { has user been told about the up-coming event? }
    exiterrors:byte=254;          { ERRORLEVEL for Critical Error exit    }
    exitnormal:byte=255;          { ERRORLEVEL for Normal exit            }
    unlisted_filepoints=5;        { file points for unlisted downloads    }

var
    first_time:boolean;           { first time loading a menu?            }
    menustack:array[1..8] of string[12]; { menu stack                     }
    menustackptr:integer;         { menu stack pointer                    }
    last_menu,                    { last menu loaded                      }
    curmenu:string;               { current menu loaded                   }
    menur:menurec;                { menu information                      }
    cmdr:array[1..50] of commandrec; { command information                }
    noc:integer;                  { # of commands on menu                 }
    fqarea,mqarea:boolean;        { file/message quick area changes       }

    doit,doitt:boolean;
    newdate:string[8];            { NewScan pointer date                  }
    lrn:integer;                  { last record # for recno/nrecno        }
    lfn:string;                     { last filename for recno/nrecno        }

    batchtime:real;               { }
    numbatchfiles:integer;        { # files in DL batch queue             }
    batch:array[1..20] of record
      fn:string[65];
      section:integer;
      pts:integer;
      blks:longint;
      tt:real;
    end;

    numubatchfiles:integer;       { # files in UL batch queue }
    ubatch:array[1..maxubatchfiles] of record
      fn:string[12];
      section:integer;
      description:string[65];
      vr:byte;
    end;
    ubatchv:array[1..maxubatchfiles] of ^verbrec;
    hiubatchv:integer;
    hdrstr:string[15];
    mbpointer:array[1..255] of byte;
    OldTempdir:string;
    tempdirchanged:boolean;
    FConf,MConf:byte;
    f2key:byte;

function lowcase(s:string):string;
procedure middle(c:string;s:string);
procedure top;
procedure bottom;
procedure header(s:string);
procedure command(s:string);
procedure calconf(cnf:byte); {1=msg, 2=file}
procedure drawWfc;
Function StripAnsi(InString : String) : String;
procedure onek(var c:char; ch:string);
procedure checkhangup;
Procedure registered;
procedure goxy(x,y:integer);
procedure writehdr(s:string);
procedure choosaprompt;
procedure oneliners;
function lenn(s:string):integer;
function lennmci(s:string):integer;
procedure loaduboard(i:integer);
procedure loadboard(i:integer);
function smci(c:char):string;
procedure sprompt(s:string);
procedure tc(n:integer);
procedure tb(n:integer);
function mso:boolean;
function fso:boolean;
function cso:boolean;
function so:boolean;
function timer:real;
function fbaseac(b:byte):boolean;
function mbaseac(nb:integer):boolean;
procedure changefileboard(b:integer);
procedure changeboard(b:integer);
function freek(d:integer):longint;    (* See disk space *)
function nma:integer;
function okansi:boolean;
function okavatar:boolean;
function nsl:real;
function ageuser(bday:string):integer;     (* returns age of user by birthdate *)
function allcaps(s:string):string;    (* returns a COMPLETELY capitalized string *)
function caps(s:string):string;                (* returns a capitalized string.. *)
function ccinkey1:char;
function cinkey1:char;
function cinkey:char;
function intime(tim:real; tim1,tim2:integer):boolean;
function getc(c:byte):string;
function sysop1:boolean;
function sysop:boolean;
function stripcolor(o:string):string;
procedure sl1(s:string);
procedure sysoplog(s:string);
function tch(s:string):string;
function time:string;
function date:string;
function value(s:string):longint;
function cstr(i:longint):string;
function nam:string;
procedure shelldos(bat:boolean; cl:string; var rcode:integer);
function leapyear(yr:integer):boolean;
function days(mo,yr:integer):integer;
function daycount(mo,yr:integer):integer;
function daynum(dt:string):integer;
function dat:string;
procedure doeventstuff;
procedure getkey(var c:char);
procedure pr1(s:string);
procedure pr(s:string);
procedure sde; {* restore curco colors (DOS and tc) loc. after local *}
procedure sdc;
procedure stsc;
procedure setc(c:byte);
procedure cl(c:integer);
procedure dosansi(c:char);
procedure prompt(s:string);
function sqoutsp(s:string):string;
function exdrv(s:string):byte;
function mln(s:string; l:integer):string;
function mlnnomci(s:string; l:integer):string;
function mlnmci(s:string; l:integer):string;
function mrn(s:string; l:integer):string;
function mn(i,l:longint):string;
procedure print(s:string);
procedure nl;
procedure prt(s:string);
procedure mpl(c:integer);
procedure prestrict(u:userrec);
procedure loadurec(var u:userrec; i:integer);
procedure saveurec(u:userrec; i:integer);
function empty:boolean;
function inkey:char;
procedure outkey(c:char);
function checkeventday(i:integer; t:real):boolean;
function checkpreeventtime(i:integer; t:real):boolean;
function checkeventtime(i:integer; t:real):boolean;
function checkevents(t:real):integer;
procedure dm(i:string; var c:char);
procedure cls;
procedure lpromptc(c:char);
procedure swac(var u:userrec; r:uflags);
function tacch(c:char):uflags;
procedure acch(c:char; var u:userrec);
procedure sprint(s:string);
procedure lcmds(len,c:byte; c1,c2:string);
procedure autovalidate(var u:userrec; un:integer);
function aonoff(b:boolean; s1,s2:string):string;
function onoff(b:boolean):string;
function syn(b:boolean):string;
procedure pyn(b:boolean);
function yn:boolean;
function pynq(Q:string;DeadDog:boolean):boolean;
function centre(s:string):string;
procedure wkey(var abort,next:boolean);
function ctim(rl:real):string;
function tlef:string;
procedure printacr(s:string; var abort,next:boolean);
function longtim(dt:datetimerec):string;
function dt2r(dt:datetimerec):real;
procedure r2dt(r:real; var dt:datetimerec);
procedure timediff(var dt:datetimerec; dt1,dt2:datetimerec);
procedure getdatetime(var dt:datetimerec);
function cstrl(li:longint):string;
function cstrr(rl:real; base:integer):string;
procedure pfl(fn:string; var abort,next:boolean; cr:boolean);
procedure printfile(fn:string);
function exist(fn:string):boolean;
function aacs1(u:userrec; un:integer; s:string):boolean;
function aacs(s:string):boolean;
procedure DisableInterrupts;
procedure EnableInterrupts;

implementation

uses tmpcom, TimeTask, common1, ansidrv, common2, mail3, common3;

var cfilter:cfilterrec;
    cfiltertype,cfilternum,cfiltercount:integer;

procedure header(s:string);
begin
sprint(#3#9+' '+#3#1+s);
end;

procedure top;
begin;
setc(8);
print('Ŀ');
end;

procedure middle(c:string;s:string);
var y:integer;
begin
setc(8);                                      {48}
y:=wherey;
prompt(' ');
setc(15);
prompt(c); setc(8); prompt('   '); setc(7);
prompt(s); setc(8);
nl;
end;

procedure bottom;
begin
setc(8);
print('');
nl;
end;

procedure command(s:string);
begin
sprompt(#3#0+'Command '+#3#5+'['+#3#1+s+#3#5+'] '+#3#0);
end;


Procedure CalConf(cnf:byte);
var clr:byte;

  Procedure FileConf;
  var fb,b,b2,i:integer;
      acc:boolean;
  begin
    b:=1;
    acc:=false;
    fb:=1;
    while (b<=maxulb) do begin
      acc:=fbaseac(b); { fbaseac will load memuboard }
      if ((fbunhidden in memuboard.fbstat) or (acc)) and
        ((memuboard.conf=common.fconf) or (common.fconf=0))
      then begin
        if (acc) then begin
          b2:=ccuboards[1][b];
          areanum[fb]:=b2;
          inc(fb);
        end;
      end;
      inc(b);
    end;
  end;

  procedure MsgConf;
  var mb,b,b2,i:integer;
      acc:boolean;
  begin
    b:=1;
    acc:=false;
    mb:=1;
    while (b<=numboards) do begin
      acc:=mbaseac(b);
      if ((mbunhidden in memboard.mbstat) or (acc)) and
        ((memboard.conf=mconf) or (mconf=0))
      then begin
        if (acc) then begin
          b2:=ccboards[1][b];
          areanum[mb]:=b2;
          inc(mb);
        end;
      end;
      inc(b);
    end;
  end;

begin
  for clr:=1 to 255 do areanum[clr]:=0;
  case cnf of
  1:msgconf;
  2:fileconf;
  end;
end;

{$I wfcm.pas}

procedure drawWfc;
   type ScreenType = array [0..3999] of Byte;
   var Screen : ScreenType absolute $B800:0000;
   begin
    clrscr;
    Move(wfcmnu,Screen,4000);
   end;

Function StripAnsi(InString : String) : String;
Const Esc         = Chr(27);
      Ansi_Letter = 'JDCABHmfsuK'+Chr(13);

Var HiC,HiB              : Byte;
    SaveAnsiX,SaveAnsiY  : Byte;
    I : Byte;
    A : Byte;
    D : Boolean;
   Begin
      D := False;
      If InString = '' Then
         Begin
            StripAnsi := '';
            Exit;
         End;
      Repeat
         Begin
            A := Pos(Chr(27)+'[',InString);
            If A > 0 Then
               Begin
                  Delete(InString,A,2);
                  I := A;
                  While (I < Length(InString)) And (Pos(InString[I],Ansi_Letter) = 0) Do
                     Inc(I);
                  Delete(InString,A,I-A+1);
               End
            Else
               D := True;
         End;
      Until D Or (InString = '');
      StripAnsi := InString;
   End;

procedure shelldos(bat:boolean; cl:string; var rcode:integer);
var t:text;
    s:string;
    i,speed:integer;
    emsswap:boolean;
    anyerrors:word;
begin
  {$I-}
  nosound;
  if (bat) then begin
    assign(t,'temp.bat'); rewrite(t);
    writeln(t,cl);
    close(t);
    cl:='temp.bat';
  end;
  if (cl<>'') then cl:='/c '+cl;    { if '', just a local shell to DOS }

  s:=^M^J+#27+'[0m';
  for i:=1 to length(s) do dosansi(s[i]);

  remove_port;

  emsswap:=FALSE;
  textcolor(7);
  if (systat.swapshell) then
    if (initexecswap(heapptr,systat.swappath+'SWAP.$$$')) then begin
      emsswap:=TRUE;
      Writeln('Allocated ',bytesswapped,' bytes.');
    end;
  swapvectors;
  if (not emsswap) then exec(getenv('COMSPEC'),cl) else begin
    textcolor(7);
    if (execwithswap(getenv('COMSPEC'),cl)<>0) then begin
      writeln('Cannot swap, performing normal execution');
      exec(getenv('COMSPEC'),cl);
    end else shutdownexecswap;
  end;
  swapvectors;

  rcode:=lo(dosexitcode);
  if (bat) then begin
    assign(t,'temp.bat');
    erase(t);
  end;
  {$I+}
  if (spd='KB') then speed:=modemr.waitbaud else speed:=value(spd);
  iport;
  com_install(modemr.comport,anyerrors,systat.fossil);
  com_set_speed(speed);
end;

procedure DisableInterrupts;
begin
  inline($FA);  {cli}
end;

procedure EnableInterrupts;
begin
  inline($FB);  {sti}
end;

procedure autovalidate(var u:userrec; un:integer);
var settings:set of uflags;
    b:boolean;
begin
  settings:=[rlogon,rchat,rvalidate,rbackspace,ramsg,rpostan,rpost,remail,
	     rvoting,rmsg,fnodlratio,fnopostratio,fnofilepts,fnodeletion];
  with u do begin
    if (un=usernum) then begin
      realsl:=sl; realdsl:=dsl;
      newcomptables;
    end;
    sl:=systat.autosl; dsl:=systat.autodsl;
    ac:=ac-settings;
    ac:=ac+(systat.autoac*settings);
      (* do NOT modify user's personal settings, such as ANSI, color, etc.. *)
    ar:=systat.autoar;
    filepoints:=systat.newfp;
    tltoday:=systat.timeallow[sl];
  end;
end;

procedure mcicolors(s:string);
var
   p,dum:string;
   r:integer;
   i,x: integer;
   pub:boolean;
   temp,xpoint,ypoint,a,first,second:string;
begin
  x:=1;
  while x <= length(s) do begin
  case s[x] of
    '|':begin
    x:=x + 1;
    first:=copy(s,x,1);
    second:=copy(s,x+1,1);
    a:=(upcase(first[1]))+(upcase(second[1]));
    if x <= length(s) then begin
    If
    a='U0' then cl(0) else if
    a='U1' then cl(1) else if
    a='U2' then cl(2) else if
    a='U3' then cl(3) else if
    a='U4' then cl(4) else if
    a='U5' then cl(5) else if
    a='U6' then cl(6) else if
    a='U7' then cl(7) else if
    a='U8' then cl(8) else if
    a='U9' then cl(9) else if
    a='B1' then setc(textattr+16) else if
    a='B2' then setc(textattr+32) else if
    a='B3' then setc(textattr+48) else if
    a='B4' then setc(textattr+64) else if
    a='B5' then setc(textattr+80) else if
    a='B6' then setc(textattr+96) else if
    a='B7' then setc(textattr+112) else if
    a='00' then setc(0) else if
    a='01' then setc(1) else If
    a='02' then setc(2) else if
    a='03' then setc(3) else if
    a='04' then setc(4) else if
    a='05' then setc(5) else if
    a='06' then setc(6) else if
    a='07' then setc(7) else if
    a='08' then setc(8) else if
    a='09' then setc(9) else if
    a='10' then setc(10) else if
    a='11' then setc(11) else if
    a='12' then setc(12) else if
    a='13' then setc(13) else if
    a='14' then setc(14) else if
    a='15' then setc(15) else if
    a='CL' then cls else if
    a='UN' then prompt(caps(thisuser.name)) else if
    a='RN' then prompt(caps(thisuser.realname)) else if
    a='PN' then prompt(thisuser.ph) else if
    a='AD' then prompt(thisuser.street) else if
    a='LO' then prompt(thisuser.citystate) else if
    a='UC' then prompt(thisuser.note) else if
    a='UL' then prompt(cstr(thisuser.sl)) else if
    a='FL' then prompt(cstr(thisuser.dsl)) else if
    a='FP' then prompt(cstr(thisuser.filepoints)) else if
    a='UK' then prompt(cstrl(thisuser.uk)) else if
    a='DK' then prompt(cstrl(thisuser.dk)) else if
    a='UD' then prompt(cstr(thisuser.uploads)) else if
    a='DN' then prompt(cstr(thisuser.downloads)) else if
    a='PS' then prompt(cstr(thisuser.msgpost)) else if
    a='CS' then prompt(cstr(thisuser.loggedon)) else if
    a='TL' then prompt(tlef) else if
    a='NF' then prompt(cstr(systat.todayzlog.uploads)) else if
    a='NP' then prompt(cstr(systat.todayzlog.pubpost)) else if
    a='CR' then prompt(spd) else if
    a='TT' then prompt(cstr(thisuser.tltoday)) else if
    a='TC' then prompt(cstr(systat.todayzlog.calls)) else if
    a='CT' then prompt(cstr(systat.callernum)) else if
    a='FT' then prompt(cstr(systat.todayzlog.uploads)) else if
    a='PT' then prompt(cstr(systat.todayzlog.pubpost)) else if
    a='NT' then prompt(cstr(systat.todayzlog.newusers)) else if
    a='UU' then prompt(cstr(small.number)) else if
    a='BN' then prompt(systat.bbsname) else if
    a='SN' then prompt(systat.sysopname) else if
    a='DT' then prompt(systat.todayzlog.date) else if
    a='TM' then prompt(cstr(thisuser.tltoday)) else if
    a='LD' then prompt(thisuser.laston) else if
    a='NN' then prompt(cstr(thisnode)) else if
    a='XY' then begin
                  temp:=s[x+5]+s[x+4]+s[x+3]+s[x+2];
                  xpoint:=temp[2]+temp[1];
                  ypoint:=temp[4]+temp[3];
                  goxy(value(xpoint),value(ypoint));
                  x:=x+4;
                end else if
    a='PA' then pausescr else if
    a='VN' then prompt('Impulse '+ver) else if
    a='VD' then prompt('05/20/95') else if
    a='CF' then prompt(memuboard.name) else if
    a='CM' then begin loadboard(board);
                  pub:=(bread<>-1);
                  prompt(aonoff(pub,memboard.name,'Private Mail'));
		end else if
    a='MN' then prompt(cstr(msg_on+1)) else if
    a='HM' then begin
                  if (bread=-1) then prompt(cstr(thisuser.waiting))
                    else prompt(cstr(himsg+1));
                end
                 else if
    a='NL' then nl else if
    a='NM' then begin
                  if (menuactiv) then prompt(menur.menuname[1]) else prompt('Main Menu');
                end else
      prompt(a);
    end;
    x:=x + 2;
    end else begin
    if (outcom) then pr1(s[x]);
    write(s[x]);
    x:=x + 1;
    end
  end;
 end;
end;

PROCEDURE GoXY(X,Y:integer);
begin
  if (spd<>'KB') then pr1(#27+'['+cstr(y)+';'+cstr(x)+'H');
  if (wantout) then gotoxy(x,y);
  pap:=0;
end;

procedure writehdr(s:string);
begin
  hdrstr:=s;
  printf('hdr.ans');
  nl;
end;

Procedure registered;
var
   x1,y1,z1,x2,y2,z2,w1,w2:real;
   b1,b2,s1,s2:string;
   rb,check:string[10];
   rx,lx,uy,ly:integer;
   color1,color2,backg,add,add2,yn2:shortint;
   yn:char;
begin
(* reset the w variables for the 'again' procedure situation *)
 b1:=systat.sysopname;
 b2:=systat.bbsname;
 w1:=0; w2:=0;
(* the equation used is ((#x)^3)(132)(ln((#x)^3))(ln(#x)) where #=0.7854 *)

 x1:=length(b1)*0.7854;
 y1:=(x1)*(x1)*(x1);
 z1:=y1*132*ln(y1)*ln(x1);

(* make sure the number is 5 digits before it is rounded*)

   if z1 >= 10000000 then w1:=z1*0.001;
   if (z1 < 10000000) and (z1 >= 1000000) then w1:=z1*0.01;
   if (z1 < 1000000) and (z1 >= 100000) then w1:=z1*0.1;
   if (z1 < 100000) and (z1 >= 10000) then w1:=z1;
   if (z1 < 10000) and (z1 >= 1000) then w1:=z1*10;
   if (z1 < 1000) and (z1 >= 100) then w1:=z1*100;
   if (z1 < 100) and (z1 >= 10) then w1:=z1*1000;
   if (z1 < 10) then w1:=z1*10000;

(* the equation used is ((#x)^3)(132)(ln((#x)^3))(ln(#x)) where #=0.5183 *)

 x2:=length(b2)*0.5183;
 y2:=(x2)*(x2)*(x2);
 z2:=y2*ln(y2)*ln(x2);

(* make sure the number is 5 digits before it is rounded*)

   if z2 >= 10000000 then w2:=z2*0.001;
   if (z2 < 10000000) and (z2 >= 1000000) then w2:=z2*0.01;
   if (z2 < 1000000) and (z2 >= 100000) then w2:=z2*0.1;
   if (z2 < 100000) and (z2 >= 10000) then w2:=z2;
   if (z2 < 10000) and (z2 >= 1000) then w2:=z2*10;
   if (z2 < 1000) and (z2 >= 100) then w2:=z2*100;
   if (z2 < 100) and (z2 >= 10) then w2:=z2*1000;
   if (z2 < 10) then w2:=z2*10000;
 str(trunc(w1),s1);               (* round the # to an interger and *)
 str(trunc(w2),s2);               (* make it a string compatible with *)
 check:=s1+s2;                    (* the systat.regnum variable*)
 rb:=systat.regnum;
 if (rb=check) or (rb='PROMPT.DAT') then registd:=true else registd:=false;
end;

procedure choosaprompt;
type
  promptrec=
  record
   prompt1:string[80];
   p1name :string[20];
   prompt2:string[80];
   p2name :string[20];
   prompt3:string[80];
   p3name :string[20];
   prompt4:string[80];
   p4name :string[20];
  end;

var c:char; finished,done:boolean; s:string;
    prmptrec:file of promptrec;
    prmp:promptrec;
begin
  finished:=false;
  assign(prmptrec,systat.gfilepath+'PROMPTS.DAT');
  reset(prmptrec);
  read(prmptrec,prmp);
  close(prmptrec);
  repeat
    cls;
    if (not exist(systat.afilepath+'prompt.*')) then begin
    writehdr('Prompt Select');
    nl;
    sprint('|U0Choose Your Prompt Type|NL');
    sprint(#3#3+'[1] '+#3#0+prmp.p1name);
    sprint(#3#3+'[2] '+#3#0+prmp.p2name);
    sprint(#3#3+'[3] '+#3#0+prmp.p3name);
    sprint(#3#3+'[4] '+#3#0+prmp.p4name);
    sprint(#3#3+'[5] '+#3#0+'MNU Default');
    nl;
    end else printf('prompt');
    sprompt(fstring.entermsg2); onek(c,'QV12345'^M);
     case c of
     'V':begin
	  nl; sprompt('View Which: '); input(s,1);
	  if (s='1') then sprint(prmp.prompt1);
	  if (s='2') then sprint(prmp.prompt2);
	  if (s='3') then sprint(prmp.prompt3);
	  if (s='4') then sprint(prmp.prompt4);
	  if (s='5') then sprint(menur.menuprompt);
	  pausescr;
	 end;
     '1':begin thisuser.prompt:=1; finished:=true; end;
     '2':begin thisuser.prompt:=2; finished:=true; end;
     '3':begin thisuser.prompt:=3; finished:=true; end;
     '4':begin thisuser.prompt:=4; finished:=true; end;
     '5':begin thisuser.prompt:=5; finished:=true; end;
     'Q',^M :finished:=true;
     end;
    until (finished);
  end;

procedure oneliners;
var ist:boolean;
    ft:text;
    i,kn:integer;
    r,s:string[70];
    sp:array[1..20] of string[70];
begin
     i:=0;
     if not exist(systat.gfilepath+'Oneline.dat') then begin
     assign(ft,systat.gfilepath+'Oneline.dat');
     rewrite(ft);
     close(ft);
     end;
     assign(ft,systat.gfilepath+'Oneline.dat');
     reset(ft);
     if ioresult<>0 then rewrite(ft);
     while not eof(ft) do begin
           readln(ft,s);
           inc(i);
           sp[i]:=s;
     end;
     Cls;
     nl;
     printf('oneltop');
     if not exist(systat.afilepath+'oneltop.*') then writehdr('Oneliners');
     nl;
     if (i>0) then for kn:=1 to i do sprint(sp[kn]) else
     sprint('No Onliners Exist!');
     printf('onelbot');
     if (not pynq(fstring.enteroneline,false)) then begin
        close(ft);
        exit;
      end;
      rewrite(ft);
      nl; sprint(#3#3+'Enter Your Oneliner'+#3#0);
      sprompt('|U5>|U1'); inputl(r,75);
      sysoplog('ONELINER: '+thisuser.name+' entered: "'+r+'"');
     if r='' then begin
       for kn:=1 to i do writeln(ft,sp[kn]);
       close(ft);
        exit;
     end;
     s:=r;
     if (I<10) then begin
        for kn:=1 to i do writeln(ft,sp[kn]);
        writeln(ft,s);
        close(ft);
     end else begin
         for kn:=2 to 10 do writeln(ft,sp[kn]);
         writeln(ft,s);
         close(ft);
         end;
      nl; sprint(#3#3'Your Oneliner was Added.');
end;

function lenn(s:string):integer;
var i,len:integer;
begin
  len:=length(s); i:=1;
  while (i<=length(s)) do begin
    if (s[i] in [#3,'^']) then
      if (i<length(s)) then begin dec(len,2); inc(i); end;
    inc(i);
  end;
  lenn:=len;
end;

function lennmci(s:string):integer;
var i,len:integer;
    lastco,lastmci:boolean;
begin
  len:=length(s);
  lastco:=FALSE; lastmci:=FALSE;
  for i:=1 to length(s) do
    if (not lastco) and (not lastmci) then
      case s[i] of
	#3,'^':if (not lastco) and (i<>length(s)) then lastco:=TRUE;
	'@':if (not lastmci) and (i<>length(s)) then lastmci:=TRUE;
      end
    else begin
      if (lastco) then
	if s[i] in [#0..#9,'0'..'9'] then begin
	  dec(len,2);
	  lastco:=FALSE;
	end;
      if (lastmci) then begin
	dec(len,2);
	inc(len,lennmci(smci(s[i])));
	lastmci:=FALSE;
      end;
    end;
  lennmci:=len;
end;

procedure loaduboard(i:integer);
var ulfo:boolean;
begin
  if (readuboard<>i) then begin
    ulfo:=(filerec(ulf).mode<>fmclosed);
    if (not ulfo) then reset(ulf);
    if ((i>=1) and (i<=filesize(ulf)-1)) then begin
      seek(ulf,i);
      read(ulf,memuboard);
    end else
      memuboard:=tempuboard;
    readuboard:=i;
    if (not ulfo) then close(ulf);
  end;
end;

procedure loadboard(i:integer);
var bfo:boolean;
begin
  if (readboard<>i) then begin
    bfo:=(filerec(bf).mode<>fmclosed);
    if (not bfo) then reset(bf);
    if ((i-1<0) or (i-1>filesize(bf)-1)) then i:=1;
    seek(bf,i-1); read(bf,memboard);
    readboard:=i;
    if (not bfo) then close(bf);
  end;
end;

procedure lcmds(len,c:byte; c1,c2:string);
var s:string;
begin
  s:=copy(c1,2,lenn(c1)-1);
  if (c2<>'') then s:=mln(s,len-1);
  sprompt('|U9[|U0'+c1[1]+'|U9]|U2'+s);
  if (c2<>'') then sprompt('|U9[|U0'+c2[1]+'|U9]|U2'+copy(c2,2,lenn(c2)-1));
  nl;
end;

procedure tc(n:integer);
begin
  textcolor(n);
end;

procedure tb(n:integer);
begin
   textbackground(n);
end;

function mso:boolean;
var i:byte;
    b:boolean;
begin
  b:=FALSE;
  for i:=1 to 5 do
    if (board=thisuser.boardsysop[i]) then b:=TRUE;
  mso:=((cso) or (aacs(systat.msop)) or (b));
end;

function fso:boolean;
begin
  fso:=((cso) or (aacs(systat.fsop)));
end;

function cso:boolean;
begin
  cso:=((so) or (aacs(systat.csop)));
end;

function so:boolean;
begin
  so:=(aacs(systat.sop));
end;

function timer:real;
var r:registers;
    h,m,s,t:real;
begin
  r.ax:=44*256;
  msdos(dos.registers(r));
  h:=(r.cx div 256); m:=(r.cx mod 256); s:=(r.dx div 256); t:=(r.dx mod 256);
  timer:=h*3600+m*60+s+t/100;
end;

function fbaseac(b:byte):boolean;
begin
  fbaseac:=FALSE;
  if ((b<0) or (b>maxulb)) then exit;
  loaduboard(b);
  fbaseac:=aacs(memuboard.acs);
end;

function mbaseac(nb:integer):boolean;
begin
  mbaseac:=FALSE;
  if ((nb<1) or (nb>numboards)) then exit;
  loadboard(nb);
  mbaseac:=aacs(memboard.acs);
end;

procedure changefileboard(b:integer);
var s:string[20];
    go:boolean;
begin
  go:=FALSE;
  if (b>=1) and (b<=maxulb) then
    if (fbaseac(b)) then { fbaseac loads memuboard itself ... }
      if (memuboard.password='') then go:=TRUE
      else begin
	nl; sprint('File base '+cstr(ccuboards[1][b])+': '+
		   #3#5+memuboard.name);
	prt('Password: '); input(s,20);
	if (s=memuboard.password) then go:=TRUE else print('Wrong.');
      end;
  if (go) then begin fileboard:=b; thisuser.lastfil:=fileboard; end;
end;

procedure changeboard(b:integer);
var s:string[20];
    go:boolean;
begin
  go:=FALSE;
  if (b>=1) and (b<=numboards) then
    if (mbaseac(b)) then { mbaseac loads memboard itself ... }
      if (memboard.password='') then go:=TRUE
      else begin
	nl; sprint('Message base '+cstr(ccboards[1][b])+': '+
		   #3#5+memboard.name);
	prt('Password: '); input(s,20);
	if (s=memboard.password) then go:=TRUE else print('Wrong.');
      end;
  if (go) then begin board:=b; thisuser.lastmsg:=board; end;
end;

function freek(d:integer):longint;
var lng:longint;
begin
  lng:=diskfree(d);
  freek:=lng div 1024;
end;

function nma:integer;
begin
  nma:=thisuser.tltoday;
end;

function okansi:boolean;
begin
  okansi:=((ansi in thisuser.ac) or (avatar in thisuser.ac));
end;

function okavatar:boolean;
begin
  okavatar:=(avatar in thisuser.ac);
end;

function nsl:real;
var ddt,dt:datetimerec;
    beenon:real;
begin
  if ((useron) or (not inwfcmenu)) then begin
    getdatetime(dt);
    timediff(ddt,timeon,dt);
    beenon:=dt2r(ddt);
    nsl:=((nma*60.0+extratime+freetime)-(beenon+choptime));
  end else
    nsl:=3600.0
end;

procedure checkhangup;
begin
  if (not com_carrier) then
    if ((outcom) and (not hangup)) then begin
      hangup:=TRUE; hungup:=TRUE;
    end;
end;

function waitackfile(s:string):boolean;
var rl:real;
begin
  pr1(^T+'f'+s+';');
  rl:=timer;
  waitackfile:=TRUE;
  repeat
    if (not com_rx_empty) then
      case com_rx of
	#6:exit;                                  { ACK }
	#21:begin waitackfile:=FALSE; exit; end;  { NAK }
      end;
  until (timer-rl>10.0);
  waitackfile:=FALSE;
end;

procedure sendfilep(s:string);
var f:file of char;
    ps:string[67];
    ns:string[8];
    es:string[4];
    c:char;
begin
  assign(f,s);
  {$I-} reset(f); {$I+}
  if (ioresult<>0) then begin
    pr('');
    pr('"'+s+'": File not found.');
    pr('');
  end else begin
    fsplit(s,ps,ns,es);
    if (waitackfile(ns+es)) then begin
      while (not eof(f)) do begin read(f,c); com_tx(c); end;
      pr1(^Z^Z^Z);
    end;
    close(f);
  end;
end;

function ccinkey1:char;
var tar:array[1..20] of char;
    rl:real;
    tarc:integer;
    c:char;
begin
  if (recom1(c)) then begin
    ccinkey1:=c;
    if (c=^A) then begin
      tarc:=1; tar[1]:=^B;
      rl:=timer;
      repeat
	if (recom1(c)) then begin tar[tarc]:=c; inc(tarc); end;
      until ((timer-rl>2.0) or (tarc>11) or (tar[1]<>^B));
    end;
  end else
    ccinkey1:=#0;
end;

function cinkey1:char;
var rl:real;
    c:char;
begin
  cinkey1:=ccinkey1;
end;

function cinkey:char;
begin
  cinkey:=cinkey1;
end;

function intime(tim:real; tim1,tim2:integer):boolean;
(* "tim" is seconds (timer) time; tim1/tim2 are minutes time. *)
begin
  intime:=TRUE;
  while (tim>=24.0*60.0*60.0) do tim:=tim-24.0*60.0*60.0;
  if (tim1<>tim2) then
    if (tim2>tim1) then
      if (tim<=tim1*60.0) or (tim>=tim2*60.0) then
	intime:=FALSE
      else
    else
      if (tim<=tim1*60.0) and (tim>=tim2*60.0) then
	intime:=FALSE;
end;

function sysop1:boolean;
var a:byte absolute $0000:$0417;
begin
  if (a and 16)=0 then sysop1:=TRUE else sysop1:=FALSE;
end;

function sysop:boolean;
var s:boolean;
begin
  s:=sysop1;
  if (not intime(timer,systat.lowtime,systat.hitime)) then s:=FALSE;
  if (rchat in thisuser.ac) then s:=FALSE;
  sysop:=s;
end;

procedure opensysopf;
begin
  assign(sysopf,systat.trappath+'sysop.'+cstr(thisnode));
  {$I-} append(sysopf); {$I+}
  if (ioresult<>0) then begin
    rewrite(sysopf);
    append(sysopf);
  end;
end;

function stripcolor(o:string):string;
var s:string;
    i:integer;
    lc:boolean;
begin
  s:=''; lc:=FALSE;
  for i:=1 to length(o) do
    if (lc) then lc:=FALSE
      else if ((o[i]=#3) or (o[i]='^')) then lc:=TRUE else s:=s+o[i];
  stripcolor:=s;
end;

procedure sl1(s:string);
begin
  if (slogging) then begin
    if (systat.stripclog) then s:=stripcolor(s);
    if (systat.slogtype in [0,1]) then begin
      if (textrec(sysopf).mode<>fmoutput) then opensysopf;
      writeln(sysopf,s);
    end;
    if ((thisuser.slogseperate) and (textrec(sysopf1).mode=fmoutput)) then
      writeln(sysopf1,s);

    if (systat.slogtype in [1,2]) then begin
      if (not systat.stripclog) then s:=stripcolor(s);
      writeln(lst,s);
    end;
  end;
end;

procedure sysoplog(s:string);
begin
  sl1('   '+s);
end;

function tch(s:string):string;
begin
  if (length(s)>2) then s:=copy(s,length(s)-1,2) else
    if (length(s)=1) then s:='0'+s;
  tch:=s;
end;

function time:string;
var h,m,s:string[3];
    hh,mm,ss,ss100:word;
begin
  gettime(hh,mm,ss,ss100);
  str(hh,h); str(mm,m); str(ss,s);
  time:=tch(h)+':'+tch(m)+':'+tch(s);
end;

function date:string;
var r:registers;
    y,m,d:string[3];
    yy,mm,dd,dow:word;
begin
  getdate(yy,mm,dd,dow);
  str(yy-1900,y); str(mm,m); str(dd,d);
  date:=tch(m)+'/'+tch(d)+'/'+tch(y);
end;

function value(s:string):longint;
var i:longint;
    j:integer;
begin
  val(s,i,j);
  if (j<>0) then begin
    s:=copy(s,1,j-1);
    val(s,i,j)
  end;
  value:=i;
  if (s='') then value:=0;
end;

function cstr(i:longint):string;
var c:string[16];
begin
  str(i,c);
  cstr:=c;
end;

function nam:string;
begin
  nam:=caps(thisuser.name)+' #'+cstr(usernum);
end;

function ageuser(bday:string):integer;
var i:integer;
begin
  i:=value(copy(date,7,2))-value(copy(bday,7,2));
  if (daynum(copy(bday,1,6)+copy(date,7,2))>daynum(date)) then dec(i);
  ageuser:=i;
end;

function allcaps(s:string):string;
var i:integer;
begin
  for i:=1 to length(s) do s[i]:=upcase(s[i]);
  allcaps:=s;
end;

function lowcase(s:string):string;
var i:integer;
begin
  for i:=1 to length(s) do
    if (s[i] in ['A'..'Z']) then s[i]:=chr(ord(s[i])+32);
  lowcase:=s;
end;

function caps(s:string):string;
var i:integer;
begin
  for i:=1 to length(s) do
    if (s[i] in ['A'..'Z']) then s[i]:=chr(ord(s[i])+32);
  for i:=1 to length(s) do
    if (not (s[i] in ['A'..'Z','a'..'z'])) then
      if (s[i+1] in ['a'..'z']) then s[i+1]:=upcase(s[i+1]);
  s[1]:=upcase(s[1]);
  caps:=s;
end;

function leapyear(yr:integer):boolean;
begin
  leapyear:=(yr mod 4=0) and ((yr mod 100<>0) or (yr mod 400=0));
end;

function days(mo,yr:integer):integer;
var d:integer;
begin
  d:=value(copy('312831303130313130313031',1+(mo-1)*2,2));
  if ((mo=2) and (leapyear(yr))) then inc(d);
  days:=d;
end;

function daycount(mo,yr:integer):integer;
var m,t:integer;
begin
  t:=0;
  for m:=1 to (mo-1) do t:=t+days(m,yr);
  daycount:=t;
end;

function daynum(dt:string):integer;
var d,m,y,t,c:integer;
begin
  t:=0;
  m:=value(copy(dt,1,2));
  d:=value(copy(dt,4,2));
  y:=value(copy(dt,7,2))+1900;
  for c:=1985 to y-1 do
    if (leapyear(c)) then inc(t,366) else inc(t,365);
  t:=t+daycount(m,y)+(d-1);
  daynum:=t;
  if y<1985 then daynum:=0;
end;

function dat:string;
const mon:array [1..12] of string[3] =
	  ('Jan','Feb','Mar','Apr','May','Jun',
	   'Jul','Aug','Sep','Oct','Nov','Dec');
var ap,x,y:string; i:integer;
    year,month,day,dayofweek,hour,minute,second,sec100:word;
begin
  getdate(year,month,day,dayofweek);
  gettime(hour,minute,second,sec100);

  if (hour<12) then ap:='am'
  else begin
    ap:='pm';
    if (hour>12) then dec(hour,12);
  end;
  if (hour=0) then hour:=12;

  dat:=cstr(hour)+':'+tch(cstr(minute))+' '+ap+'  '+
       copy('SunMonTueWedThuFriSat',dayofweek*3+1,3)+' '+
       mon[month]+' '+cstr(day)+', '+cstr(year);
end;

procedure pr1(s:string);
var i:integer;
begin
  for i:=1 to length(s) do sendcom1(s[i]);
end;

procedure pr(s:string);
begin
  pr1(s+#13);
end;

procedure scc;    {* make local textcolor( = curco *}
var f:integer;
begin
  if (okansi) then begin
    f:=curco and 7;
    if (curco and 8)<>0 then inc(f,8);
    if (curco and 128)<>0 then inc(f,16);
    tc(f);
    textbackground((curco shr 4) and 7);
  end;
end;

procedure sde; { restore curco colors (DOS and tc) loc. after local }
var c:byte;
    b:boolean;
begin
  if (okansi) then begin
    c:=curco; curco:=255-curco;
    b:=outcom; outcom:=FALSE;
    setc(c);
    outcom:=b;
  end;
end;

procedure sdc; { restore curco colors (DOS and tc) loc/rem after loc/rem }
var c:byte;
begin
  if (okansi) then begin
    c:=curco; curco:=255-curco;
    setc(c);
  end;
end;

procedure stsc;
begin
  tc(11); textbackground(0);
end;

function getc(c:byte):string;
const xclr:array[0..7] of char=('0','4','2','6','1','5','3','7');
var s:string;
    b:boolean;

  procedure adto(ss:string);
  begin
    if (s[length(s)]<>';') and (s[length(s)]<>'[') then s:=s+';';
    s:=s+ss; b:=TRUE;
  end;

begin
  b:=FALSE;
  if ((curco and (not c)) and $88)<>0 then begin
    s:=#27+'[0';
    curco:=$07;
  end else
    s:=#27+'[';
  if (c and 7<>curco and 7) then adto('3'+xclr[c and 7]);
  if (c and $70<>curco and $70) then adto('4'+xclr[(c shr 4) and 7]);
  if (c and 128<>0) then adto('5');
  if (c and 8<>0) then adto('1');
  if (not b) then adto('3'+xclr[c and 7]);
  s:=s+'m';
  getc:=s;
end;

procedure setc(c:byte);
var s:string;
    i:integer;
begin
  if ((c<>curco) or (dosansion)) then begin
    s:=getc(c); curco:=c;
    if (okansi) then begin
      if (outcom) then
        pr1(s);
      if (wantout) then begin
        textattr:=c;
        if (dosansion) then begin
          s:=#27+'[0;'+copy(s,3,length(s)-2);
          for i:=1 to length(s) do dosansi(s[i]);
        end;
      end;
    end;
    scc;
  end;
end;

procedure cl(c:integer);
begin
  if (c in [0..9]) then
    if (okansi) then
      setc(thisuser.cols[(color in thisuser.ac)][c]);
end;

function sqoutsp(s:string):string;
begin
  while (pos(' ',s)>0) do delete(s,pos(' ',s),1);
  sqoutsp:=s;
end;

function exdrv(s:string):byte;
begin
  s:=fexpand(s);
  exdrv:=ord(s[1])-64;
end;

function mlnnomci(s:string; l:integer):string;
begin
  while (length(s)<l) do s:=s+' ';
  if (length(s)>l) then
    repeat s:=copy(s,1,length(s)-1) until (length(s)=l) or (length(s)=0);
  mlnnomci:=s;
end;

function mlnmci(s:string; l:integer):string;
begin
  while (lennmci(s)<l) do s:=s+' ';
  if (lennmci(s)>l) then
    repeat s:=copy(s,1,length(s)-1) until (lennmci(s)=l) or (length(s)=0);
  mlnmci:=s;
end;

function mln(s:string; l:integer):string;
begin
  while (lenn(s)<l) do s:=s+' ';
  if (lenn(s)>l) then
    repeat s:=copy(s,1,length(s)-1) until (lenn(s)=l) or (length(s)=0);
  mln:=s;
end;

function mrn(s:string; l:integer):string;
begin
  while lenn(s)<l do s:=' '+s;
  if lenn(s)>l then s:=copy(s,1,l);
  mrn:=s;
end;

function mn(i,l:longint):string;
begin
  mn:=mln(cstr(i),l);
end;

procedure dosansi(c:char);
begin
  writecharansi(c);
end;

procedure lpromptc(c:char);
var ss:string;
    bb:byte;
begin
  if (c=^G) then exit;
  case c of
    ^H:if (pap>0) then dec(pap);
    ^J:begin
	 if ((not ch) and (not write_msg) and (not reading_a_msg)) then
	   if (not ctrljoff) then begin
	     bb:=thisuser.cols[color in thisuser.ac][1];
	     if ((outcom) and (okansi)) then
	       pr1(getc(bb));
	     curco:=bb; textattr:=bb;
	   end else
	     lil:=0;
	 if (wantout) then write(^J);
	 inc(lil);
	 if (lil>=thisuser.pagelen-1) then begin
	   lil:=0;
	   if (pause in thisuser.ac) then pausescr;
	 end;
	 exit;
       end;
    ^L:lil:=0;
    ^M:pap:=0;
    ^[:dosansion:=TRUE;
  end;
  if (wantout) then if (not dosansion) then write(c) else dosansi(c);
end;

procedure prompt(s:string);
var s1,s2:string;
    i:integer;
    bb:byte;
begin
  checkhangup;
  if (hangup) then exit;
  if (outcom) then begin
    s1:=s;
    while (pos(^J,s1)<>0) do begin
      i:=pos(^J,s1);
      s2:=copy(s,1,i-1); s1:=copy(s1,i+1,length(s1)-i);
      for i:=1 to length(s2) do sendcom1(s2[i]);
      if ((not ch) and (not write_msg) and (not reading_a_msg)) then
	if (not ctrljoff) then begin
	  bb:=thisuser.cols[color in thisuser.ac][1];
	  if (okansi) then
	    pr1(getc(bb));
	  curco:=bb;
	end else
	  lil:=0;
      sendcom1(^J);
    end;
    for i:=1 to length(s1) do sendcom1(s1[i]);
  end;
  for i:=1 to length(s) do lpromptc(s[i]);
  if (trapping) then
    if (copy(s,length(s)-1,2)=^M^J) then
      writeln(trapfile,copy(s,1,length(s)-2))
    else
      write(trapfile,s);
end;

procedure print(s:string);
begin
  prompt(s+^M^J);
end;

procedure nl;
begin
  prompt(^M^J);
end;

procedure prt(s:string);
begin
  cl(4); sprompt(s); cl(3);
end;

procedure mpl(c:integer);
begin
end;

function smci(c:char):string;
begin
end;

function substone(src,old,new:string):string;
var p:integer;
begin
  if (old<>'') then begin
    p:=pos(old,allcaps(src));
    if (p>0) then begin
      insert(new,src,p+length(old));
      delete(src,p,length(old));
    end;
  end;
  substone:=src;
end;

procedure sprompt(s:string);
var ss,sss:string;
    r,i,p1,p2,x,z:integer;
    c,mc:char;
    xx,b:boolean;
begin
  checkhangup;
  if (hangup) then exit;
  ss:=s; sss:='';
  b:=FALSE;
  if (pos('~~',ss)=1) then begin
    if (not write_msg) and (not reading_a_msg) then
    begin
      ss:=copy(ss,3,length(ss));
      common2.printf(ss);
    end;
  end else
  if (pos('|',ss)<>0) and (value((s[pos('|',ss)+1])+(s[pos('|',ss)+2]))<=15) and
    (value((s[pos('|',ss)+1])+(s[pos('|',ss)+2]))>=0) then
  begin
    if (cfgbbs) then delete(ss,1,2);
    mcicolors(ss);
  end else
  begin
  if (trapping) then write(trapfile,ss);
  if (not okansi) then
    ss:=stripcolor(ss)
  else
    while (ss<>'') and ((pos(#3,ss)<>0) or (pos('^',ss)<>0)) do begin
      p1:=pos(#3,ss); if (p1=0) then p1:=500;
      p2:=pos('^',ss); if (p2=0) then p2:=500;

      if (p2<p1) then p1:=p2;

      if (p1<>500) then begin
	mc:=ss[p1+1]; sss:=copy(ss,1,p1-1);
	ss:=copy(ss,p1+2,length(ss)-(p1+1));
      end else begin
	sss:=ss; ss:='';
      end;

      if (outcom) then
	for i:=1 to length(sss) do sendcom1(sss[i]);
      for i:=1 to length(sss) do lpromptc(sss[i]);

      if ((mc>=#0) and (mc<=#9)) then cl(ord(mc)) else
	if ((mc>='0') and (mc<='9')) then cl(ord(mc)-48);
    end;
  if (outcom) then
    for i:=1 to length(ss) do sendcom1(ss[i]);
  for i:=1 to length(ss) do lpromptc(ss[i]);
  end;
end;

procedure sprint(s:string);
begin
  sprompt(s);
  nl;
end;

procedure prestrict(u:userrec);
var r:uflags;
begin
  for r:=rlogon to rmsg do
    if (r in u.ac) then write(copy('LCVBA*PEKM',ord(r)+1,1)) else write('-');
  writeln;
end;

function empty:boolean;
var e:boolean;
begin
  e:=(not keypressed);
  if ((incom) and (e)) then e:=(com_rx_empty);
  if (hangup) then begin com_flush_rx; e:=TRUE; end;
  empty:=e;
end;

function inkey:char;
var c:char;
begin
  c:=#0; inkey:=#0;
  checkhangup;
  if (keypressed) then begin
    c:=readkey;
    if ((c=#0) and (keypressed)) then begin
      c:=readkey;
      skey1(c);
      if (c=#68) then c:=#1 else if((c<>'H') and (c<>'P')) then c:=#0;
      if (buf<>'') then begin
	c:=buf[1];
	buf:=copy(buf,2,length(buf)-1);
      end;
    end;
    inkey:=c;
  end else
    if (incom) then inkey:=cinkey;
end;

procedure outtrap(c:char);
begin
  if (c<>^G) then write(trapfile,c);
end;

procedure docc2(c:char);
var i:integer;
begin
  case c of
    ^G:if (outcom) then for i:=1 to 4 do sendcom1(#0);
    ^J:begin
	 if (wantout) then write(^J);
	 inc(pap);
       end;
    ^L:begin
	 if (wantout) then clrscr;
	 lil:=0;
       end;
  end;
end;

procedure outkey(c:char);
begin
  if (c=#29) then exit;
  if (not echo) then
    if ((systat.localsec) and (c in [#32..#255])) then c:=fstring.echoc;
  if (c=#27) then dosansion:=TRUE;
  if (not (c in [^J,^L])) then
    if (not ((c=^G) and (incom))) then
      if ((c<>#0) and (not nopfile) and (wantout)) then
        if (not dosansion) then write(c) else dosansi(c);
  if ((not echo) and (c in [#32..#255])) then c:=fstring.echoc;
  if (outcom) then sendcom1(c);
  if (c<#32) then docc2(c);
end;

function checkeventday(i:integer; t:real):boolean;
var s:string;
    year,month,day,dayofweek:word;
    e:integer;
begin
  checkeventday:=FALSE;
  with events[i]^ do begin
    getdate(year,month,day,dayofweek);
    e:=0;
    if (timer+t>=24.0*60.0*60.0) then begin
      inc(dayofweek); e:=1;
      if (dayofweek>6) then dayofweek:=0;
    end;
    if (monthly) then begin
      if (value(copy(date,4,2))+e=execdays) then
	checkeventday:=TRUE;
    end else begin
      if ((1 shl (6-dayofweek)) and execdays<>0) then
	checkeventday:=TRUE;
    end;
  end;
end;

function checkpreeventtime(i:integer; t:real):boolean;
begin
  with events[i]^ do
    if (busytime=0) then
      checkpreeventtime:=FALSE
    else
      checkpreeventtime:=intime(timer+t,exectime-busytime,exectime);
end;

function checkeventtime(i:integer; t:real):boolean;
begin
  with events[i]^ do
    if (duration=0) then
      checkeventtime:=FALSE
    else
      checkeventtime:=intime(timer+t,exectime,exectime+duration);
end;

function checkevents(t:real):integer;
var i:integer;
begin
  for i:=0 to numevents do
    with events[i]^ do
      if (active) then
	if (checkeventday(i,t)) then begin
	  checkevents:=i;
	  if (checkpreeventtime(i,t)) or (checkeventtime(i,t)) then begin
	    if (etype in ['D','E','P']) then exit;
	    if ((etype='A') and (not aacs(execdata)) and (useron)) then exit;
	  end;
	end;
  checkevents:=0;
end;

procedure dm(i:string; var c:char);
begin
  buf:=i;
  if (buf<>'') then begin
    c:=buf[1];
    buf:=copy(buf,2,length(buf)-1);
  end;
end;

procedure doeventstuff;
var s:string;
    e,savpap:integer;
    aaa:boolean;
begin
  case telluserevent of
    0:begin
	oltime:=timer;
	e:=checkevents(systat.eventwarningtime);
	if (e<>0) then begin
	  telluserevent:=1;
	  nl;
	  sysoplog('[> '+date+' '+time+' - Displayed "REVENT'+cstr(e)+'" in preparation for event #'+cstr(e));
	  savpap:=pap;
	  aaa:=allowabort; allowabort:=FALSE;
	  printf('revent'+cstr(e));
	  allowabort:=aaa;
	  if (nofile) then begin
	    nl; nl;
	    sprint(#3#8+^G'Warning: '+#3#5+'System event approaching.'^G);
	    sprint(#3#5+^G'System will be shut down in '+
		    copy(ctim(systat.eventwarningtime),4,5)+' minutes.'^G);
	    nl; nl;
	  end;
	  pap:=savpap;
	end else
	  if (checkevents(0)=0) then telluserevent:=0;
      end;
    1:begin
	oltime:=timer;
	e:=checkevents(0);
	if (e<>0) then begin
	  telluserevent:=2;
	  sysoplog('[> '+date+' '+time+' - Logged user off in preparation for '+
		   'event #'+cstr(e));
	  nl; nl; sprint(#3#8+^G'Shutting down for system events'^G); nl; nl;
	  hangup:=TRUE;
	end;
      end;
  end;
end;

procedure getkey(var c:char);
var dt,ddt:datetimerec;
    aphase,e:integer;
    abort,next,b,tf,t1,bufalready:boolean;
begin
  lil:=0;
  if (buf<>'') then begin
    c:=buf[1];
    buf:=copy(buf,2,length(buf)-1);
  end else begin
    if (not empty) then begin
      if (ch) then c:=chinkey else c:=inkey;
    end else begin
      getdatetime(tim);
      t1:=FALSE; tf:=FALSE;
      c:=#0;
      if (alert in thisuser.ac) then aphase:=1 else aphase:=0;
      while ((c=#0) and (not hangup)) do begin
	if (aphase<>0) then begin
	  case aphase of
	    1:begin sound(1000); delay(35); end;
	    2:begin sound(1500); delay(40); end;
	    3:begin sound(1900); delay(45); end;
	    4:begin sound(2300); delay(50); end;
	    5:begin sound(3400); delay(55); end;
	  end;
	  aphase:=aphase mod 5+1;
	end;

	if (ch) then c:=chinkey else c:=inkey;
	getdatetime(dt);
	timediff(ddt,tim,dt);
	if (systat.timeout<>-1) and
	   (dt2r(ddt)>systat.timeout*60) and (c=#0) then begin
	  nl; nl;
	  printf('timedout');
	  if (nofile) then
	    print('Time out has occurred.  Log off time was at '+time+'.');
	  nl; nl;
	  hangup:=TRUE;
	  sysoplog(#3#7+'- Time-out at '+time+' -');
	end;
	if (systat.timeoutbell<>-1) and
	   (dt2r(ddt)>systat.timeoutbell*60) and (not tf) and (c=#0) then begin
	  tf:=TRUE;
	  outkey(^G); delay(100); outkey(^G);
	end;
	checkhangup;
      end;
      nosound;
    end;
  end;
end;

procedure cls;
begin
  if (okansi) then begin
    if (outcom) then begin
      pr(#27+'[2J');
    end;
    if (wantout) then begin setc(7+0); clrscr; end;
  end else
    outkey(^L);
  if (trapping) then writeln(trapfile,^L);
  cl(1);
  lil:=0;
end;

procedure swac(var u:userrec; r:uflags);
begin
  if (r in u.ac) then
    u.ac:=u.ac-[r] else u.ac:=u.ac+[r];
end;

function tacch(c:char):uflags;
begin
  case c of
    'L':tacch:=rlogon;
    'C':tacch:=rchat;
    'V':tacch:=rvalidate;
    'B':tacch:=rbackspace;
    'A':tacch:=ramsg;
    '*':tacch:=rpostan;
    'P':tacch:=rpost;
    'E':tacch:=remail;
    'K':tacch:=rvoting;
    'M':tacch:=rmsg;
    '1':tacch:=fnodlratio;
    '2':tacch:=fnopostratio;
    '3':tacch:=fnofilepts;
    '4':tacch:=fnodeletion;
  end;
end;

procedure acch(c:char; var u:userrec);
begin
  swac(u,tacch(c));
end;

function aonoff(b:boolean; s1,s2:string):string;
begin
  if (b) then aonoff:=s1 else aonoff:=s2;
end;

function onoff(b:boolean):string;
begin
  if (b) then onoff:='On ' else onoff:='Off';
end;

function syn(b:boolean):string;
begin
   if (b) then syn:='Yes' else syn:='No ';
end;

procedure pyn(b:boolean);
begin
  print(syn(b));
end;

function yn:boolean;
var c:char;
    s:string;
    yes,no:boolean;
begin
  yn:=pynq('',false);
end;

function pynq(Q:string;DeadDog:boolean):boolean;
var c:char;
    s:string;
    yes,no:boolean;
begin
  sprompt(q+' ');
  if (not hangup) then
    cl(3);
    if (deaddog) then s:=#3#6+' Yes '+#3#0+' No ' else
       s:=#3#0+' Yes '+#3#6+' No ';
    sprompt(s);
    pynq:=deaddog;
    repeat
     repeat
      getkey(c);
      c:=upcase(c);
     until (c in [' ','Y','N','C','D',^M,^N]) or (hangup);
    case c of
     ' ':if (deaddog) then
            begin
              prt(^H^H^H^H^H^H^H^H^H); sprompt(#3#0+' Yes '+#3#6+' No ');
              pynq:=false;
              deaddog:=false;
            end else
            begin
              prt(^H^H^H^H^H^H^H^H^H); sprompt(#3#6+' Yes '+#3#0+' No ');
              pynq:=true;
              deaddog:=true;
            end;
     'N':begin
     prt(^H^H^H^H^H^H^H^H^H); sprompt(#3#0+' Yes '+#3#6+' No ');
     pynq:=false; c:=^M;
     deaddog:=false;
     end;
     'C':begin
     prt(^H^H^H^H^H^H^H^H^H); sprompt(#3#0+' Yes '+#3#6+' No ');
     pynq:=false;
     deaddog:=false;
     end;
     'Y': begin
     prt(^H^H^H^H^H^H^H^H^H); sprompt(#3#6+' Yes '+#3#0+' No ');
     pynq:=true; c:=^M;
     deaddog:=false;
     end;
     'D': begin
     prt(^H^H^H^H^H^H^H^H^H); sprompt(#3#6+' Yes '+#3#0+' No ');
     pynq:=true;
     deaddog:=true;
     end;
    end;
   until (c=^M) or (c='Y') or (c='N');
   nl; nl;
  if (hangup) then pynq:=FALSE;
end;

procedure onek(var c:char; ch:string);
var s:string;
begin
  repeat
    if (not (onekey in thisuser.ac)) then begin
      input(s,3);
      if length(s)>=1 then c:=s[1] else
	if (s='') and (pos(^M,ch)<>0) then c:=^M else
	  c:=' ';
    end else getkey(c);
  until (pos(upcase(c),ch)>0) or (hangup);
  if (hangup) then c:=ch[1];
  if (onekey in thisuser.ac) then begin
    if (onekda) then
      if (c in [#13,#32..#255]) then begin
	outkey(c);
	if (trapping) then write(trapfile,c);
      end;
    if (onekcr) then nl;
  end;
  onekcr:=TRUE;
  onekda:=TRUE;
  c:=upcase(c);
end;

function centre(s:string):string;
var i,j:integer;
begin
  if (pap<>0) then nl;
  if (s[1]=#2) then s:=copy(s,2,length(s)-1);
  i:=length(s); j:=1;
  while (j<=length(s)) do begin
    if s[j]=#3 then begin
      dec(i,2);
      inc(j);
    end;
    inc(j);
  end;
  if i<thisuser.linelen then
    s:=copy('                                               ',1,
      (thisuser.linelen-i) div 2)+s;
  centre:=s;
end;

procedure wkey(var abort,next:boolean);
var c:char;
begin
  if (empty) then exit;
  if ((abort) or (hangup)) then exit;

  getkey(c);
  case upcase(c) of
  ' ',^C,^Y,^K:abort:=TRUE;
	  'N',^N:begin abort:=TRUE; next:=TRUE; end;
	  'P',^S:getkey(c);
  end;
  if (not allowabort) then begin abort:=FALSE; next:=FALSE; end;
  if (abort) then begin com_purge_tx; nl; sprint(fstring.aborted); end;
end;

function ctim(rl:real):string;
var h,m,s:string;
begin
  s:=tch(cstr(trunc(rl-int(rl/60.0)*60.0)));
  m:=tch(cstr(trunc(int(rl/60.0)-int(rl/3600.0)*60.0)));
  h:=cstr(trunc(rl/3600.0));
  if (length(h)=1) then h:='0'+h;
  ctim:=h+':'+m+':'+s;
end;

function tlef:string;
begin
  tlef:=ctim(nsl);
end;

function longtim(dt:datetimerec):string;
var s:string;
    d:integer;

  procedure ads(comma:boolean; i:integer; lab:string);
  begin
    if (i<>0) then begin
      s:=s+cstrl(i)+' '+lab;
      if (i<>1) then s:=s+'s';
      if (comma) then s:=s+', ';
    end;
  end;

begin
  s:='';
  with dt do begin
    d:=day;
    if (d>=7) then begin
      ads(TRUE,d div 7,'week');
      d:=d mod 7;
    end;
    ads(TRUE,d,'day');
    ads(TRUE,hour,'hour');
    ads(TRUE,min,'minute');
    ads(FALSE,sec,'second');
  end;
  if (s='') then s:='0 seconds';
  if (copy(s,length(s)-1,2)=', ') then s:=copy(s,1,length(s)-2);
  longtim:=s;
end;

function dt2r(dt:datetimerec):real;
begin
  with dt do
    dt2r:=day*86400.0+hour*3600.0+min*60.0+sec;
end;

procedure r2dt(r:real; var dt:datetimerec);
begin
  with dt do begin
    day:=trunc(r/86400.0); r:=r-(day*86400.0);
    hour:=trunc(r/3600.0); r:=r-(hour*3600.0);
    min:=trunc(r/60.0); r:=r-(min*60.0);
    sec:=trunc(r);
  end;
end;

procedure timediff(var dt:datetimerec; dt1,dt2:datetimerec);
begin
  with dt do begin
    day:=dt2.day-dt1.day;
    hour:=dt2.hour-dt1.hour;
    min:=dt2.min-dt1.min;
    sec:=dt2.sec-dt1.sec;

    if (hour<0) then begin inc(hour,24); dec(day); end;
    if (min<0) then begin inc(min,60); dec(hour); end;
    if (sec<0) then begin inc(sec,60); dec(min); end;
  end;
end;

procedure getdatetime(var dt:datetimerec);
var w1,w2,w3,w4:word;
begin
  gettime(w1,w2,w3,w4);
  with dt do begin
    day:=daynum(date);
    hour:=w1;
    min:=w2;
    sec:=w3;
  end;
end;

function cstrl(li:longint):string;
var c:string;
begin
  str(li,c);
  cstrl:=c;
end;

function cstrr(rl:real; base:integer):string;
var i:integer;
    s:string;
    r1,r2:real;
begin
  if (rl<=0.0) then cstrr:='0'
  else begin
    r1:=ln(rl)/ln(1.0*base);
    r2:=exp(ln(1.0*base)*(trunc(r1)));
    s:='';
    while (r2>0.999) do begin
      i:=trunc(rl/r2);
      s:=s+copy('0123456789ABCDEF',i+1,1);
      rl:=rl-i*r2;
      r2:=r2/(1.0*base);
    end;
    cstrr:=s;
  end;
end;

procedure printa1(s:string; var abort,next:boolean);
var s1,s2,ss,sss,ssss,tcode,mcix,mcixx:string;
    i,ls,p1,p2,p3:integer;
    c,mc:char;
    savcurco:byte;
    isansi,iscolor,ismci,istcode,usetcodes:boolean;

  function nmci(c:char):string;
  begin
  end;

  procedure domci(c:char);
  begin
  end;

  procedure dotcode(c:char; var s:string);
  var s1,s2:string;
  begin
    case mc of
      'c':if (pos(';',s)<>0) then begin
            s1:=copy(s,1,pos(';',s)-1);
            delete(s,1,length(s1)+1);
          end;
      'C':begin
            if (okansi) then setc(ord(s[1]));
            delete(s,1,1);
          end;
    end;
  end;

  procedure sends(s:string);
  var i:word;
  begin
    i:=0;
    while (i<length(s)) do begin
      inc(i);
      sendcom1(s[i]);
    end;
  end;

  procedure locs(s:string);
  var i:integer;
  begin
    i:=0;
    while (i<length(s)) do begin
      inc(i);
      lpromptc(s[i]);
    end;
  end;

  procedure handlecolors;
  label goto1;
  begin
      goto1:  { ack! }
    mc:=ss[p1+1]; sss:=copy(ss,1,p1-1);
    ss:=copy(ss,p1+2,length(ss)-(p1+1));

    if (outcom) then sends(sss);
    locs(sss);

    if ((mc>=#0) and (mc<=#9)) then cl(ord(mc)) else
      if ((mc>='0') and (mc<='9')) then cl(ord(mc)-48);

    p1:=pos(#3,ss);
    if (p1<>0) then goto goto1;
  end;

  procedure handletcodes;
  label goto1;  { *ACK!* }
  begin
      goto1:
    if ((p3<p2) and (p3<>0)) then begin
      istcode:=TRUE;
      p2:=p3;
    end else
      istcode:=FALSE;

    mc:=ss[p2+1]; sss:=copy(ss,1,p2-1);
    ss:=copy(ss,p2+2,length(ss)-(p2+1));

    if (outcom) then sends(sss);
    locs(sss);

    if (not istcode) then domci(mc) else
      dotcode(mc,ss);

    p2:=pos('@',ss); p3:=pos(^T,ss);
    if (p2+p3>0) then goto goto1;
  end;

  procedure handletcodesc;
  label goto1;  { **ACK!!!*!*!***** }
  begin
      goto1:
    if (p2<>500) then
      if (pos(ss[p2+1],mcixx)=0) then p2:=500;

    iscolor:=TRUE; istcode:=FALSE;
    if ((p2<p1) or (p3<p1)) then
      if ((p2<p1) and (p2<p3)) then begin p1:=p2; iscolor:=FALSE; end else
        if (p3<p1) then begin p1:=p3; iscolor:=FALSE; istcode:=TRUE; end;

    mc:=ss[p1+1]; sss:=copy(ss,1,p1-1);
    ss:=copy(ss,p1+2,length(ss)-(p1+1));

    if (outcom) then sends(sss);
    locs(sss);

    if (iscolor) then begin
      if ((mc>=#0) and (mc<=#9)) then cl(ord(mc)) else
        if ((mc>='0') and (mc<='9')) then cl(ord(mc)-48);
    end else
      if (not istcode) then domci(mc) else
        dotcode(mc,ss);

    p1:=pos(#3,ss); if (p1=0) then p1:=500;
    p2:=pos('@',ss); if (p2=0) then p2:=500;
    p3:=pos(^T,ss); if (p3=0) then p3:=500;
    if (p1+p2+p3<1500) then goto goto1;
  end;

begin
  tcode:=''; ss:='';
  if (abort) then exit;
  doit:=TRUE; isansi:=FALSE;
  if (pos(^[,s)<>0) then begin
    lil:=0;
    isansi:=TRUE;
  end else
    if (s[1]='&') then begin
      if (thisuser.sl<value(copy(s,2,4))) then doit:=FALSE;
      s:=copy(s,5,length(s)-4);
    end;
  if ((hangup) or (not doit)) then begin abort:=TRUE; exit; end;
  ss:=s; sss:=''; i:=1;
  mcix:=''; mcixx:='';
  while (pos(#29,ss)<>0) do delete(ss,pos(#29,ss),1);
  if (not okansi) then ss:=stripcolor(ss);
  if (trapping) then write(trapfile,ss);

    p1:=pos(#3,ss); if (p1=0) then p1:=500;
    p2:=pos('@',ss); if (p2=0) then p2:=500;
    p3:=pos(^T,ss); if (p3=0) then p3:=500;
    if (isansi) then begin
      p1:=500; p2:=500; p3:=500;
    end;

    if (((reading_a_msg) and (not read_with_mci)) and (p2+p3<>1000)) then
      begin p2:=500; p3:=500; end;

    if ((p2=500) and (p3=500)) then begin
      if (p1<>500) then handlecolors;
    end else
      if (p1=500) then handletcodes else handletcodesc;
    if (outcom) then sends(ss);
    locs(ss);
  wkey(abort,next);
end;

procedure printacr(s:string; var abort,next:boolean);
var org:string;
    p,op,rp,rop,nca:integer;
    okdoit,sram,turnoff:boolean;

  procedure doboxedtitle(s:string);
  const B_UL=''; B_UR=''; B_LL=''; B_LR='';
        B_TOP=''; B_BOT=''; B_LFT=''; B_RGT='';
  var b:array[0..7] of char;
      x,numsp:integer;
      i:string;

    function ritr(c:char; l:integer):string;
    var s:string;
        i:integer;
    begin
      s:='';
      for i:=1 to l do s:=s+c;
      ritr:=s;
    end;

  begin
    i:=s;
    if (i[length(i)]=#1) then i:=copy(i,1,length(i)-1);
    if (okansi) then
      for x:=0 to 7 do
        case x of
          0:b[x]:=B_UL;   1:b[x]:=B_UR;   2:b[x]:=B_LL;  3:b[x]:=B_LR;
          4:b[x]:=B_TOP;  5:b[x]:=B_BOT;  6:b[x]:=B_LFT; 7:b[x]:=B_RGT;
        end
    else
      for x:=0 to 7 do
        case x of
          0:b[x]:='.';  1:b[x]:='.';  2:b[x]:='`';  3:b[x]:='''';
          4:b[x]:='-';  5:b[x]:='-';  6:b[x]:=':';  7:b[x]:=':';
        end;
    numsp:=(thisuser.linelen div 2)-((lenn(i)+4) div 2);
    printacr(#3#4+ritr(#32,numsp)+b[0]+ritr(b[4],lenn(i)+2)+b[1],abort,next);
    printacr(#3#4+ritr(#32,numsp)+b[6]+' '+#3#3+i+#3#4+' '+b[7],abort,next);
    printacr(#3#4+ritr(#32,numsp)+b[2]+ritr(b[5],lenn(i)+2)+b[3]+#3#1,abort,next);
  end;

begin
  if ((allowabort) and (abort)) then exit;

  if (s[length(s)]=#1) then
    if (copy(s,length(s)-1,1)<>#3) then s:=copy(s,1,length(s)-1);

  okdoit:=TRUE; abort:=FALSE; nopfile:=FALSE;
  turnoff:=(s[length(s)]=#29);

  if (copy(s,1,1)='&') then begin
    if (thisuser.sl<value(copy(s,2,4))) then exit;
    s:=copy(s,5,length(s)-4);
  end;
  checkhangup;


  if (pos(^[,s)>0) then begin
    printa1(s,abort,next);
    if ((not turnoff) and (not croff)) then begin
      nl;
      if (trapping) then writeln(trapfile);
    end;
    croff:=FALSE;
    exit;
  end else
  if (s[1]=#2) then begin
    printa1(centre(s),abort,next);
    if (not turnoff) then nl;
    croff:=FALSE; exit;
  end else
  if (length(s)>=3) and (copy(s,1,3)=BOXEDTITLE) then begin
    doboxedtitle(copy(s,4,length(s)-3));
    croff:=FALSE; exit;
  end else begin
    printa1(s,abort,next);
    if (abort) then begin curco:=255-curco; cl(1); end;
    if ((not nofeed) and (doit) and (not croff) and (not turnoff)) then
      if (not abort) then nl;
    doit:=TRUE;
  end;
  croff:=FALSE;
end;

procedure pfl(fn:string; var abort,next:boolean; cr:boolean);
var fil:text;
    ofn:string;
    ls:string[255];
    ps:integer;
    c:char;
    oldpause,oaa:boolean;
begin
  cfiltertype:=0; cfilternum:=0; cfiltercount:=0;
  printingfile:=TRUE;
  oaa:=allowabort;
  allowabort:=TRUE;
  abort:=FALSE; next:=FALSE;
  oldpause:=(pause in thisuser.ac);
  nofile:=FALSE;
  if (not hangup) then begin
    assign(fil,sqoutsp(fn));
    {$I-} reset(fil); {$I+}
    if (ioresult<>0) then nofile:=TRUE
    else begin
      abort:=FALSE;
      while ((not eof(fil)) and (not nofile) and
             (not abort) and (not hangup)) do begin
        ps:=0;
        repeat
          inc(ps);
          read(fil,ls[ps]);
        until ((ls[ps]=^M) or (ps=255) or (eof(fil)) or (hangup));
        ls[0]:=chr(ps);
        if (ls[ps]=^M) then begin
          if (not eof(fil)) then read(fil,c);
          ls[0]:=chr(ps-1);
        end else
          croff:=TRUE;
        if (pos(^[,ls)<>0) then ctrljoff:=TRUE;
        printacr(ls,abort,next);
      end;
      close(fil);
    end;
  end;
  if (oldpause) then thisuser.ac:=thisuser.ac+[pause];
  allowabort:=oaa;
  printingfile:=FALSE; ctrljoff:=FALSE;
  curco:=255-curco; cl(1);
  redrawforansi;
end;

function exist(fn:string):boolean;
var srec:searchrec;
    t:text;
begin
  findfirst(sqoutsp(fn),anyfile,srec);
  exist:=(doserror=0);
end;

procedure printfile(fn:string);
var s:string;
    abort,next:boolean;
begin
  fn:=allcaps(fn); s:=fn;
  pfl(fn,abort,next,TRUE);
end;

function aacs1(u:userrec; un:integer; s:string):boolean;
var s1,s2:string;
    p1,p2,i,j:integer;
    c,c1,c2:char;
    b:boolean;

  procedure getrest;
  begin
    s1:=c;
    p1:=i;
    if ((i<>1) and (s[i-1]='!')) then begin s1:='!'+s1; dec(p1); end;
    if (c in ['C','F','G','R','V','X']) then begin
      s1:=s1+s[i+1];
      inc(i);
    end else begin
      j:=i+1;
      repeat
	if (s[j] in ['0'..'9']) then begin
	  s1:=s1+s[j];
	  inc(j);
	end;
      until ((j>length(s)) or (not (s[j] in ['0'..'9'])));
      i:=j-1;
    end;
    p2:=i;
  end;

  function argstat(s:string):boolean;
  var vs:string;
      year,month,day,dayofweek,hour,minute,second,sec100:word;
      vsi:integer;
      boolstate,res:boolean;
  begin
    boolstate:=(s[1]<>'!');
    if (not boolstate) then s:=copy(s,2,length(s)-1);
    vs:=copy(s,2,length(s)-1); vsi:=value(vs);
    case s[1] of
      'A':res:=(ageuser(u.bday)>=vsi);
      'B':res:=((value(spd)>=value(vs+'00')) or (spd='KB'));
      'C':res:=FALSE;   { conferences - not implemented yet }
      'D':res:=(u.dsl>=vsi);
      'F':res:=(upcase(vs[1]) in u.ar);
      'G':res:=(u.sex=upcase(vs[1]));
      'H':begin
	    gettime(hour,minute,second,sec100);
	    res:=(hour=vsi);
	  end;
      'P':res:=(u.filepoints>=vsi);
      'R':res:=(tacch(upcase(vs[1])) in u.ac);
      'S':res:=(u.sl>=vsi);
      'T':res:=(trunc(nsl) div 60>=vsi);
      'U':res:=(un=vsi);
      'V':res:=((u.sl>systat.newsl) or (u.dsl>systat.newdsl) or
	   ((systat.newsl=systat.autosl) and (systat.newdsl=systat.autodsl)));
      'W':begin
	    getdate(year,month,day,dayofweek);
	    res:=(dayofweek=ord(s[1])-48);
	  end;
      'Y':res:=(trunc(timer) div 60>=vsi);
    end;
    if (not boolstate) then res:=not res;
    argstat:=res;
  end;

begin
  s:=allcaps(s);
  i:=0;
  while (i<length(s)) do begin
    inc(i);
    c:=s[i];
    if (c in ['A'..'Z']) and (i<>length(s)) then begin
      getrest;
      b:=argstat(s1);
      delete(s,p1,length(s1));
      if (b) then s2:='^' else s2:='%';
      insert(s2,s,p1);
      dec(i,length(s1)-1);
    end;
  end;
  s:='('+s+')';
  while (pos('&',s)<>0) do delete(s,pos('&',s),1);
  while (pos('^^',s)<>0) do delete(s,pos('^^',s),1);
  while (pos('(',s)<>0) do begin
    i:=1;
    while ((s[i]<>')') and (i<=length(s))) do begin
      if (s[i]='(') then p1:=i;
      inc(i);
    end;
    p2:=i;
    s1:=copy(s,p1+1,(p2-p1)-1);
    while (pos('|',s1)<>0) do begin
      i:=pos('|',s1);
      c1:=s1[i-1]; c2:=s1[i+1];
      s2:='%';
      if ((c1 in ['%','^']) and (c2 in ['%','^'])) then begin
	if ((c1='^') or (c2='^')) then s2:='^';
	delete(s1,i-1,3);
	insert(s2,s1,i-1);
      end else
	delete(s1,i,1);
    end;
    while(pos('%%',s1)<>0) do delete(s1,pos('%%',s1),1);   {leave only "%"}
    while(pos('^^',s1)<>0) do delete(s1,pos('^^',s1),1);   {leave only "^"}
    while(pos('%^',s1)<>0) do delete(s1,pos('%^',s1)+1,1); {leave only "%"}
    while(pos('^%',s1)<>0) do delete(s1,pos('^%',s1),1);   {leave only "%"}
    delete(s,p1,(p2-p1)+1);
    insert(s1,s,p1);
  end;
  aacs1:=(not (pos('%',s)<>0));
end;

function aacs(s:string):boolean;
begin
  aacs:=aacs1(thisuser,usernum,s);
end;

procedure loadurec(var u:userrec; i:integer);
var ufo:boolean;
begin
  ufo:=(filerec(uf).mode<>fmclosed);
  if (not ufo) then reset(uf);
  if (i<>usernum) then begin
    seek(uf,i);
    read(uf,u);
  end else
    u:=thisuser;
  if (not ufo) then close(uf);
end;

procedure saveurec(u:userrec; i:integer);
var ufo:boolean;
begin
  ufo:=(filerec(uf).mode<>fmclosed);
  if (not ufo) then reset(uf);
  seek(uf,i); write(uf,u);
  if (i=usernum) then thisuser:=u;
  if (not ufo) then close(uf);
end;

end.
