{$A+,B+,D-,F+,I+,L-,O+,R-,S-,V-,Q-}
{$M 55520,0,55520}      { Memory Allocation Sizes }

Program Impulse;
Uses
  Crt,      Dos,      OverLay,  InitP,    Sysop3,   Menus2,
  Sysop7,   Sysop8,   Sysop9,   Sysop10,  Sysop11,  Crc_Calc,
  Mail0,    Mail1,    Mail2,    Mail3,    Mail4,    Mail5,
  Mail6,    Mail9,    File0,    File1,    File2,    File4,
  File5,    File6,    File8,    File9,    File10,   File11,
  File12,   File13,   File14,   Misc1,    TimeTask, WfcMenu,
  Misc2,    Misc3,    Misc4,    MiscX,    CUser,    Doors,
  Menus3,   Menus4,   MyIO,     Logon1,   Logon2,   NewUsers,
  Menus,    TimeJunk, Tmpcom,   MsgPack,  Common,   Common1,
  multinod, Common2,  Common3,  ExecSwap, Ulcheck;

{$O MsgPack   } {$O Common1   } {$O InitP     } {$O Misc3     }
{$O Multinod  } {$O Msgpack   } {$O UlCheck   } {$O Mail1     }
{$O Sysop7    } {$O Sysop7m   } {$O Common3   } {$O ZIPviewu  }
{$O Wfcmenu   } {$O Menus     } {$O Menus2    } {$O Menus3    }
{$O Sysop10   } {$O Sysop11   } {$O Mail0     } {$O CUser     }
{$O Mail2     } {$O Mail3     } {$O Mail4     } {$O Mail5     }
{$O Mail6     } {$O Mail7     } {$O File3     } {$O LZHview   }
{$O Mail9     } {$O File0     } {$O File1     } {$O File2     }
{$O File4     } {$O File5     } {$O File6     } {$O File8     }
{$O File9     } {$O File10    } {$O File11    } {$O File12    }
{$O File14    } {$O Logon1    } {$O Mail6     } {$O File13    }
{$O Logon2    } {$O NewUsers  } {$O Misc1     } {$O Misc2     }
{$O Misc4     } {$O MiscX     } {$O ExecBat   } {$O TimeTask  }
{$O Sysop3    } {$O Menus4    } {$O Sysop3    } {$O Logon1    }
{$O Script    } {$O Sysop2s   } {$O TheUnit   } {$O Sysop2    }
{$O Conf      }

Var
  ExitSave  : Pointer;
  ExecFirst : Boolean;
  ExitingBBS : Boolean;
  NewMenuCmd : String[80];

Procedure ErrorHandle;
{$F-}
begin
  if ErrorAddr <> Nil then begin
    Writeln;
    Writeln('Impulse terminated with error number ',ExitCode,'.');
      case ExitCode of
        1..18     : write('DOS ERROR: ');
        100..106  : write('I/O ERROR: ');
        150..162,
        200..216  : write('CRITICAL ERROR: ');
      end;
      Case ExitCode of
          0 : writeln('Authorized Program Termination.');
          1 : Writeln('Invalid function number.');
          2 : Writeln('File not found.');
          3 : Writeln('Path not found.');
          4 : Writeln('Too many open files.');
          5 : Writeln('File access denied.');
          6 : Writeln('Invalid file handle.');
         12 : Writeln('Invalid file access code.');
         15 : Writeln('Invalid drive number.');
         16 : Writeln('Cannot remove current directory.');
         17 : Writeln('Cannot rename across drives.');
         18 : Writeln('No More Files.');
        100 : Writeln('Disk read error.');
        101 : Writeln('Disk write error.');
        102 : Writeln('File not assigned.');
        103 : Writeln('File not open.');
        104 : Writeln('File not open for input.');
        105 : Writeln('File not open for output.');
        106 : Writeln('Invalid numeric format.');
        150 : Writeln('Disk is write-protected.');
        151 : Writeln('Unknown unit.');
        152 : Writeln('Drive not ready.');
        153 : Writeln('Unknown command.');
        154 : Writeln('CRC error in data.');
        155 : Writeln('Bad drive request structure length.');
        156 : Writeln('Disk seek error.');
        157 : Writeln('Unknown media type.');
        158 : Writeln('Sector not found.');
        159 : Writeln('Printer out of paper.');
        160 : Writeln('Device write fault.');
        161 : Writeln('Device read fault.');
        162 : Writeln('Hardware failure.');
        200 : Writeln('Division by zero.');
        201 : Writeln('Range check error.');
        202 : Writeln('Stack overflow error.');
        203 : Writeln('Heap overflow error.');
        204 : Writeln('Invalid pointer operation.');
        205 : Writeln('Floating point overflow.');
        206 : Writeln('Floating point underflow.');
        207 : Writeln('Invalid floating point operation.');
        208 : Writeln('Overlay manager not installed.');
        209 : Writeln('Overlay file read error.');
        210 : Writeln('Object not initialized.');
        211 : Writeln('Call to abstract method.');
        212 : Writeln('Stream registration error.');
        213 : Writeln('Collection index out of range.');
        214 : Writeln('Collection overflow error.');
        215 : Writeln('Arithmetic overflow error.');
        216 : Writeln('General Protection fault.');
        250 : Writeln('Fossil Driver not installed.');
      else
        Writeln( ^G + 'Unknown Error.');
      end; { Case }
    ErrorAddr := Nil;
  end;
  Exitproc := ExitSave;   { Restore original exit address }
end; { ErrorExit }

procedure HighBackground(On: boolean);
var DisplayRegs    : Registers;
Begin
 With DisplayRegs Do
 Begin
   AX := $1003;
   BL := Ord(Not On);
   Intr($10,DisplayRegs);
 End;
end;

Procedure MenuExec;
Var
  Dt    : LDateTimeRec;
  Cmd,s : String;
  I     : Integer;
  Aa,Abort,Next,Done:Boolean;
Begin
  If (ExecFirst) then
  Begin
    ExecFirst:=FALSE;
    Cmd:=NewMenuCmd;
    NewMenuCmd:='';
  End Else MainMenuHandle(Cmd);

  if ((copy(cmd,1,2)='\\') and (thisuser.sl=255)) then begin
    domenucommand(done,copy(cmd,3,length(cmd)-2),newmenucmd);
    if (newmenucmd<>'') then cmd:=newmenucmd else cmd:='';
  end;

  If (Cmd='|') then
  Begin
   cls;
   sprint('|NLImpulse v'+ver);
   sprint('Released on 05/20/95');
   sprint('(c)1994,95 Nivenh');
   registered;
   if registd then begin
     sprint('Registered Sysop: '+systat.sysopname);
     sprint('Registered BBS  : '+systat.bbsname+' ('+systat.bbsphone+')');
   end else
     writeunregd;
   registd:=false;
   pausescr;
  end
    else
  newmenucmd:='';
  if (cmd='') then repeat domenuexec('ENTER',newmenucmd) until (newmenucmd='');
  repeat domenuexec(cmd,newmenucmd) until (newmenucmd='');
end;

function Share:boolean; assembler;
asm
  mov ax,$1000
  int $2f
end;


Procedure DoBBS;
Var
  TaskerName,OvrPath : String;
  beginln,I,RCode         : Integer;
  NeedToHangup    : Boolean;
  SyStatF         : File of systatrec;
  Fr : File;

Begin
  ExitingBBS:=False;
  if (not share) then begin
    writeln;
    writeln('SHARE.EXE Must be Installed.');
    writeln;
    halt(0);
  end;

  exitsave:=exitproc;
  exitproc:=@errorhandle;
  MaxHeapSpace:=40000;

  checksnow:=TRUE; directvideo:=FALSE;

  useron:=FALSE; usernum:=0;
  getdir(0,start_dir);

  assign(systatf,'status.dat');
  {$I-} reset(systatf); {$I+}
  if (ioresult<>0) then
  begin
    writeln;
    writeln('Unable to find STATUS.DAT data file.');
    writeln;
    if (exiterrors<>-1) then halt(exiterrors) else halt(254);
  end else begin
    {$I-} read(systatf,systat); {$I+}
    close(systatf);
  end;
  usefossil:=true;

  ovrinit('IMP.OVR');
  ovrpath:=fsearch('IMP.OVR',getenv('PATH'));

  if (ovrresult<>ovrok) then
  begin
   clrscr; writeln('Critical error: Overlay manager error.'); halt(1);
  end;
  if (systat.useems) then
  begin
    ovrinitems; if (ovrresult=ovrok) then overlayinems:=TRUE;
  end;

  InitMulti;
  if (task.os=1) then taskername:='Windows ' else
  if (task.os=2) then taskername:='OS/2 ' else
  if (task.os=3) then taskername:='DesqView ' else
  if (task.os=4) then taskername:='TopView ';

  clrscr;
  textcolor(7);

  registered;

  if (systat.sysopname='Nivenh') and (registd) then ver:=ver+' Alpha';
  if (systat.sysopname='Tyme') and (registd) then ver:=ver+' Alpha';
  if (systat.sysopname='Sexman') and (registd) then ver:=ver+' Alpha';
  if (systat.sysopname='Verbatum') and (registd) then ver:=ver+' Alpha';
  if (systat.sysopname='Bad Sector') and (registd) then ver:=ver+' Alpha';

  if (systat.specialfx) then highbackground(true) else highbackground(false);
  textcolor(23);
  gotoxy(1,1); for beginln:=1 to 80 do write(' ');
  cwritecentered(1,'Impulse v'+ver+' Startup Sequence');
  window(1,2,80,25);

  textcolor(7); textbackground(0);
  writeln;
  if (task.os=0) then writeln('Multitasker = No Multitasker Detected.') else
  Writeln('Multitasker = '+taskername,hi(task.version),'.',lo(task.version),' Detected.');

  init;

  if (packbasesonly) then
  begin
    wfcmdefine; doshowpackbases; thisuser.ac:=thisuser.ac-[pause]; nl;
    sprint(#3#5+'Message bases have been packed.');
    cursoron(TRUE); ExitingBBS:=true; halt(0);
  end;
  mailread:=FALSE;
  needtohangup:=false;
  while (not doneday) do begin
    write_msg:=FALSE;
    sysopon:=not systat.localsec;
    wantout:=not systat.localscreensec;
    checksnow:=systat.cgasnow;

    wfcmenus(needtohangup);
    needtohangup:=FALSE;

    useron:=FALSE; usernum:=0;
    if (not doneday) then
    while (not hangup) do begin
      if (getuser) then newuser;
      if (not hangup) then
      begin
        macok:=TRUE;
        if (not hangup) then logon;
        if (not hangup) then
        begin
          with thisuser do
          begin
            newdate:=laston;
            if (not mbaseac(lastmsg)) then lastmsg:=1;
            if (not fbaseac(lastfil)) then lastfil:=1;
            if lastmsg=0 then lastmsg:=1;
            if lastfil=0 then lastmsg:=1;
            board:=lastmsg; fileboard:=lastfil;
          end;
          batchtime:=0.0; numbatchfiles:=0; numubatchfiles:=0; hiubatchv:=0;
          newcomptables;

          menustackptr:=0; for i:=1 to 8 do menustack[i]:='';

          last_menu:=systat.allstartmenu+'.MNU';

          if (not exist(systat.menupath+last_menu)) then
          begin
            sysoplog('"'+systat.menupath+last_menu+'" is MISSING.');
            last_menu:=systat.allstartmenu;
          end;
          curmenu:=systat.menupath+last_menu; readin;

          if (novice in thisuser.ac) then chelplevel:=2 else chelplevel:=1;
        end;

        newmenucmd:=''; i:=1;
        while ((i<=noc) and (newmenucmd='')) do
        begin
          if (cmdr[i].ckeys='FIRSTCMD') then
            if (aacs(cmdr[i].acs)) then newmenucmd:='FIRSTCMD';
          inc(i);
        end;
        execfirst:=(newmenucmd='FIRSTCMD');
        while (not hangup) do menuexec;    {*** main BBS loop ***}
      end;

      if (quitafterdone) then
      begin
        elevel:=exitnormal; hangup:=TRUE; doneday:=TRUE; needtohangup:=TRUE;
      end;
      logoff;
      if (not doneday) then sl1(#3#3+'Logoff '+#3#5+'['+dat+']');

      if (textrec(sysopf1).mode=fmoutput) then
      begin
        {$I-} close(sysopf1); {$I+}
        if (ioresult<>0) then writeln('Errors closing SLOGxxxx.LOG');
      end;

      if ((com_carrier) and (not doneday)) then
        if (spd<>'KB') then needtohangup:=TRUE;
    end;
  end; {while not hangup/doneday}
  {until (doneday);}

  if (needtohangup) then hangupphone;
  reset(sysopf); close(sysopf);
  term_ready(TRUE); remove_port;
  makenode(0);
  makenodeon('Nobody',0);

  if (exist('bbsdone.bat')) then shelldos(FALSE,'bbsdone.bat',rcode);

{Delete file stuff}
  if (systat.globaltrap) then begin
    assign(fr,systat.trappath+'trap.msg');
    if exist(systat.trappath+'trap.msg')
      then erase(fr);
  end;

  assign(fr,'nodemess.dat');
  if exist('nodemess.dat') then erase(fr);
  assign(fr,'msgtmp');
  if exist('msgtmp') then erase(fr);
  assign(fr,'forum1.gen');
  if exist('forum1.gen') then erase(fr);
  assign(fr,'forum1.jaf');
  if exist('forum1.jaf') then erase(fr);
  assign(fr,'multicht.1');
  if exist('multicht.1') then erase(fr);
  assign(fr,'fi.lst');
  if exist('fi.lst') then erase(fr);

  clrscr;
  tc(15); textbackground(0);
  writeln('Impulse v'+ver);
  writeln;
  tc(3); writeln('Copybreastuses by Nivenh');
  tc(8); WriteLn('Exited with ErrorLevel ',elevel);
  writeln;
  writeln('Don''t forget to wipe!');
  tc(15); writeln; writeln;
  setc(7);
  ExitingBBS:=True;
  TextAttr := 7;    { OldAttr initialized at Program startup }
  Write(' '^H);
end;

Begin
  DoBBS;
End.

